-- initialize defaults
DMT_Default = {
	["Ace of Waves"] = {["minbuyout"] = 0, ["existed"] = 0, ["name"] = "Ace of Waves"},
	["Two of Waves"] = {["minbuyout"] = 0, ["existed"] = 0, ["name"] = "Two of Waves"},
	["Three of Waves"] = {["minbuyout"] = 0, ["existed"] = 0, ["name"] = "Three of Waves"},
	["Four of Waves"] = {["minbuyout"] = 0, ["existed"] = 0, ["name"] = "Four of Waves"},
	["Five of Waves"] = {["minbuyout"] = 0, ["existed"] = 0, ["name"] = "Five of Waves"},
	["Six of Waves"] = {["minbuyout"] = 0, ["existed"] = 0, ["name"] = "Six of Waves"},
	["Seven of Waves"] = {["minbuyout"] = 0, ["existed"] = 0, ["name"] = "Seven of Waves"},
	["Eight of Waves"] = {["minbuyout"] = 0, ["existed"] = 0, ["name"] = "Eight of Waves"},
	["Ace of Embers"] = {["minbuyout"] = 0, ["existed"] = 0, ["name"] = "Ace of Embers"},
	["Two of Embers"] = {["minbuyout"] = 0, ["existed"] = 0, ["name"] = "Two of Embers"},
	["Three of Embers"] = {["minbuyout"] = 0, ["existed"] = 0, ["name"] = "Three of Embers"},
	["Four of Embers"] = {["minbuyout"] = 0, ["existed"] = 0, ["name"] = "Four of Embers"},
	["Five of Embers"] = {["minbuyout"] = 0, ["existed"] = 0, ["name"] = "Five of Embers"},
	["Six of Embers"] = {["minbuyout"] = 0, ["existed"] = 0, ["name"] = "Six of Embers"},
	["Seven of Embers"] = {["minbuyout"] = 0, ["existed"] = 0, ["name"] = "Seven of Embers"},
	["Eight of Embers"] = {["minbuyout"] = 0, ["existed"] = 0, ["name"] = "Eight of Embers"},
	["Ace of the Winds"] = {["minbuyout"] = 0, ["existed"] = 0, ["name"] = "Ace of the Winds"},
	["Two of the Winds"] = {["minbuyout"] = 0, ["existed"] = 0, ["name"] = "Two of the Winds"},
	["Three of the Winds"] = {["minbuyout"] = 0, ["existed"] = 0, ["name"] = "Three of the Winds"},
	["Four of the Winds"] = {["minbuyout"] = 0, ["existed"] = 0, ["name"] = "Four of the Winds"},
	["Five of the Winds"] = {["minbuyout"] = 0, ["existed"] = 0, ["name"] = "Five of the Winds"},
	["Six of the Winds"] = {["minbuyout"] = 0, ["existed"] = 0, ["name"] = "Six of the Winds"},
	["Seven of the Winds"] = {["minbuyout"] = 0, ["existed"] = 0, ["name"] = "Seven of the Winds"},
	["Eight of the Winds"] = {["minbuyout"] = 0, ["existed"] = 0, ["name"] = "Eight of the Winds"},
	["Ace of Stones"] = {["minbuyout"] = 0, ["existed"] = 0, ["name"] = "Ace of Stones"},
	["Two of Stones"] = {["minbuyout"] = 0, ["existed"] = 0, ["name"] = "Two of Stones"},
	["Three of Stones"] = {["minbuyout"] = 0, ["existed"] = 0, ["name"] = "Three of Stones"},
	["Four of Stones"] = {["minbuyout"] = 0, ["existed"] = 0, ["name"] = "Four of Stones"},
	["Five of Stones"] = {["minbuyout"] = 0, ["existed"] = 0, ["name"] = "Five of Stones"},
	["Six of Stones"] = {["minbuyout"] = 0, ["existed"] = 0, ["name"] = "Six of Stones"},
	["Seven of Stones"] = {["minbuyout"] = 0, ["existed"] = 0, ["name"] = "Seven of Stones"},
	["Eight of Stones"] = {["minbuyout"] = 0, ["existed"] = 0, ["name"] = "Eight of Stones"}
}

DMT_Query = ""

-- set slashcommand
SLASH_Darkmoon_Tracker1 = '/dmt';

local dmt_frame_hidden = 1;

function SlashCmdList.Darkmoon_Tracker(msg, editbox)
	if dmt_frame_hidden == 1 then
		DarkmoonTrackerFrame:Show();
		dmt_frame_hidden = 0;
	else
		DarkmoonTrackerFrame:Hide();
		dmt_frame_hidden = 1;
	end
end

function Clicked(self)
	if AuctionFrame and AuctionFrame:IsVisible() then
		DMT_CurrentQuery = 1
		RegisterEvents()
		SendQueries(self:GetText())
	else
		message("You need to talk to the auctioneer before using this button!")
	end
end

function Show_DMT_Table(self)
	LoadLineText(DMT_Aces)
	LoadLineText(DMT_Twos)
	LoadLineText(DMT_Threes)
	LoadLineText(DMT_Fours)
	LoadLineText(DMT_Fives)
	LoadLineText(DMT_Sixes)
	LoadLineText(DMT_Sevens)
	LoadLineText(DMT_Eights)
	CalculateTotals(DMT_Totals)
	DMT_Table:Show()
end

function Hide_DMT_Table(self)
	DMT_Table:Hide()
end

function RegisterEvents()	
	Listener:RegisterEvent("AUCTION_ITEM_LIST_UPDATE")	
	Listener:RegisterEvent("VARIABLES_LOADED")
end

function SendQueries(query)
	Listener:RegisterEvent("AUCTION_ITEM_LIST_UPDATE")
	if (CanSendAuctionQuery()) then
		DMT_Query = query;
		QueryAuctionItems(query, 0, 0, 0, 0, 0, 0, 0, 3, 0)
	end
end

function Listener_OnEvent(self, event, test)
	Listener:UnregisterEvent("AUCTION_ITEM_LIST_UPDATE")
	Listener:UnregisterEvent("VARIABLES_LOADED")
	if (event=="AUCTION_ITEM_LIST_UPDATE") then

		local name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, 
			highBidder, owner;
		i = GetNumAuctionItems("list")

		for key,value in next,DMT_Stored,nil do 
			-- set all existed values to 0 so we can track
			-- which were actually in the AH at the time of scan
			if (string.find(value.name, DMT_Query)) then
				value.existed = 0
			end
		end

		for x = 1, i do
			name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, 
			highBidder, owner = GetAuctionItemInfo("list", x)
			if (not DMT_Stored[name]) then
				-- it's not in the list of preset values, continue
			else
				if (buyoutPrice/10000 < DMT_Stored[name].minbuyout or DMT_Stored[name].minbuyout == 0) then
					DMT_Stored[name].minbuyout = buyoutPrice/10000
				end		
				DMT_Stored[name].existed = 1
			end
		end
	end
	if (event=="VARIABLES_LOADED") then
		DMT_VariablesLoaded()
	end
end

function DMT_VariablesLoaded()
	if (not DMT_Stored or not DMT_Stored["Ace of Waves"].name) then
		DMT_Stored = DMT_Default;
	end
end

function LoadLineText(self)
	if (not DMT_Stored) then -- the array hasnt been loaded yet
		return
	end

	local text = self:GetText()

	while (string.find(text, " ") == 1) do
		text = string.sub(text, 2)
	end

	local index = string.find(text, " ")
	local row

	if (index) then -- its not nil, which means a space exists
		row = string.sub(text, 1, index-1)
	else
		row = text
	end


	local Waves = DMT_Stored[row.." of Waves"];
	local Embers = DMT_Stored[row.." of Embers"];
	local Winds = DMT_Stored[row.." of the Winds"];
	local Stones = DMT_Stored[row.." of Stones"];

	self:SetText(string.format("%10s %12.2f %12.2f %12.2f %12.2f", 
		row, Waves.minbuyout, Embers.minbuyout, Winds.minbuyout, Stones.minbuyout))
end

function CalculateTotals(self)
	local Waves = DMT_Stored["Ace of Waves"].minbuyout + DMT_Stored["Two of Waves"].minbuyout +
				DMT_Stored["Three of Waves"].minbuyout + DMT_Stored["Four of Waves"].minbuyout +
				DMT_Stored["Five of Waves"].minbuyout + DMT_Stored["Six of Waves"].minbuyout +
				DMT_Stored["Seven of Waves"].minbuyout + DMT_Stored["Eight of Waves"].minbuyout
	local Embers = DMT_Stored["Ace of Embers"].minbuyout + DMT_Stored["Two of Embers"].minbuyout +
				DMT_Stored["Three of Embers"].minbuyout + DMT_Stored["Four of Embers"].minbuyout +
				DMT_Stored["Five of Embers"].minbuyout + DMT_Stored["Six of Embers"].minbuyout +
				DMT_Stored["Seven of Embers"].minbuyout + DMT_Stored["Eight of Embers"].minbuyout
	local Winds = DMT_Stored["Ace of the Winds"].minbuyout + DMT_Stored["Two of the Winds"].minbuyout +
				DMT_Stored["Three of the Winds"].minbuyout + DMT_Stored["Four of the Winds"].minbuyout +
				DMT_Stored["Five of the Winds"].minbuyout + DMT_Stored["Six of the Winds"].minbuyout +
				DMT_Stored["Seven of the Winds"].minbuyout + DMT_Stored["Eight of the Winds"].minbuyout
	local Stones = DMT_Stored["Ace of Stones"].minbuyout + DMT_Stored["Two of Stones"].minbuyout +
				DMT_Stored["Three of Stones"].minbuyout + DMT_Stored["Four of Stones"].minbuyout +
				DMT_Stored["Five of Stones"].minbuyout + DMT_Stored["Six of Stones"].minbuyout +
				DMT_Stored["Seven of Stones"].minbuyout + DMT_Stored["Eight of Stones"].minbuyout

	self:SetText(string.format("%10s %12.2f %12.2f %12.2f %12.2f", 
		"Totals =", Waves, Embers, Winds, Stones))

end

function Reset_DMT_Table(self)
	for key,value in next,DMT_Stored,nil do 
		value.minbuyout = 0
	end
end